"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var helper_plugin_utils_1 = require("@babel/helper-plugin-utils");
var ast_builders_1 = require("./utils/ast-builders");
var css_prop_1 = require("./css-prop");
var styled_1 = require("./styled");
exports.default = helper_plugin_utils_1.declare(function (api) {
    api.assertVersion(7);
    return {
        inherits: require('babel-plugin-syntax-jsx'),
        visitor: {
            ImportDeclaration: function (path, state) {
                if (path.node.source.value === '@compiled/core') {
                    state.compiledImportFound = true;
                    path.node.specifiers = path.node.specifiers
                        .filter(function (specifier) {
                        return specifier.local.name !== 'styled' && specifier.local.name !== 'ClassNames';
                    })
                        .concat([ast_builders_1.importSpecifier('CC'), ast_builders_1.importSpecifier('CS')]);
                }
            },
            TaggedTemplateExpression: function (path, state) {
                if (!state.compiledImportFound) {
                    return;
                }
                styled_1.visitStyledPath(path, { state: state, parentPath: path });
            },
            CallExpression: function (path, state) {
                if (!state.compiledImportFound) {
                    return;
                }
                styled_1.visitStyledPath(path, { state: state, parentPath: path });
            },
            JSXOpeningElement: function (path, state) {
                if (!state.compiledImportFound) {
                    return;
                }
                css_prop_1.visitCssPropPath(path, { state: state, parentPath: path });
            },
        },
    };
});
//# sourceMappingURL=index.js.map